package eu.trade.client.normalizer;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;

import eu.trade.repo.search.codecs.impl.CMISStringPropertyTypeNormalizer;



public class PropertyNormalizerJob {

	private static final Logger LOG = LoggerFactory.getLogger(PropertyNormalizerJob.class);


	public static void main(String[] args){

		LOG.info("BEGIN normalizer");
		
		ClassPathXmlApplicationContext applicationContext = new ClassPathXmlApplicationContext("classpath:/META-INF/applicationContext-normalizer.xml");
		
		LOG.info("Spring context initialized.");

		CMISStringPropertyTypeNormalizer normalizer = (CMISStringPropertyTypeNormalizer) applicationContext.getBean("stringPropertyTypeNormalizer");
		DataSourceTransactionManager transactionManager = (DataSourceTransactionManager) applicationContext.getBean("jdbcTxManagerIndex");
		NamedParameterJdbcTemplate jdbcTemplate = (NamedParameterJdbcTemplate) applicationContext.getBean("jdbcTemplateIndex");
		
		JDBCDelegate jdbcDelegate = new JDBCDelegate(transactionManager, jdbcTemplate);
		jdbcDelegate.normalize(normalizer);
		
		applicationContext.close();
		LOG.info("END normalizer");
	}
}
